// Code generated by go-swagger; DO NOT EDIT.

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// UserGetSelfHandlerFunc turns a function with the right signature into a user get self handler
type UserGetSelfHandlerFunc func(UserGetSelfParams) middleware.Responder

// Handle executing the request and returning a response
func (fn UserGetSelfHandlerFunc) Handle(params UserGetSelfParams) middleware.Responder {
	return fn(params)
}

// UserGetSelfHandler interface for that can handle valid user get self params
type UserGetSelfHandler interface {
	Handle(UserGetSelfParams) middleware.Responder
}

// NewUserGetSelf creates a new http.Handler for the user get self operation
func NewUserGetSelf(ctx *middleware.Context, handler UserGetSelfHandler) *UserGetSelf {
	return &UserGetSelf{Context: ctx, Handler: handler}
}

/*UserGetSelf swagger:route GET /api/users/self Users userGetSelf

Get self user

*/
type UserGetSelf struct {
	Context *middleware.Context
	Handler UserGetSelfHandler
}

func (o *UserGetSelf) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserGetSelfParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
